diff --git a/tests/Feature/Http/Controllers/Web/TwoFactorControllerTest.php b/tests/Feature/Http/Controllers/Web/TwoFactorControllerTest.php
new file mode 100644
index 0000000..f947904
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Web/TwoFactorControllerTest.php
@@ -0,0 +1,411 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Web;
+
+use Authy;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Events\User\TwoFactorEnabled;
+use Portal\Events\User\TwoFactorEnabledByAdmin;
+use Portal\Repositories\User\UserRepository;
+use Portal\User;
+
+class TwoFactorControllerTest extends FunctionalTestCase
+{
+    /** @test */
+    public function the_2fa_form_is_visible_on_profile_page_if_2fa_is_enabled()
+    {
+        config(['services.authy.key' => 'test']);
+
+        $this->setSettings(['2fa.enabled' => false]);
+
+        $this->createAndLoginUser();
+
+        $this->visit("profile")
+            ->dontSee('Two-Factor Authentication');
+
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        $this->visit("profile")
+            ->see('Two-Factor Authentication');
+    }
+
+    /** @test */
+    public function the_2fa_form_is_visible_on_edit_user_page_if_2fa_is_enabled()
+    {
+        config(['services.authy.key' => 'test']);
+
+        $this->setSettings(['2fa.enabled' => false]);
+
+        $this->createAndLoginAdminUser();
+
+        $user = factory(User::class)->create();
+
+        $this->visit("/user/{$user->id}/edit")
+            ->dontSee('Two-Factor Authentication');
+
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginAdminUser();
+
+        $user = factory(User::class)->create();
+
+        $this->visit("/user/{$user->id}/edit")
+            ->see('Two-Factor Authentication');
+    }
+
+    /** @test */
+    public function enable_2fa_from_profile_page()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $user = $this->createAndLoginUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('register')->andReturnNull();
+        Authy::shouldReceive('sendTwoFactorVerificationToken')->andReturnNull();
+
+        $this->visit("profile")
+            ->submitForm('Enable', ['country_code' => '1', 'phone_number' => '123'])
+            ->seePageIs("two-factor/verification")
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => 1,
+                'two_factor_phone' => 123
+            ]);
+    }
+
+    /** @test */
+    public function enable_2fa_from_edit_user_page()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginAdminUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('register')->andReturnNull();
+        Authy::shouldReceive('sendTwoFactorVerificationToken')->andReturnNull();
+
+        $user = factory(User::class)->create();
+
+        $this->visit("/user/{$user->id}/edit")
+            ->submitForm('Enable', ['country_code' => '1', 'phone_number' => '123'])
+            ->seePageIs("two-factor/verification?user={$user->id}")
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => 1,
+                'two_factor_phone' => 123
+            ]);
+    }
+
+    /** @test */
+    public function users_without_appropriate_permissions_cannot_enable_2fa_for_other_users()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('register')->andReturnNull();
+        Authy::shouldReceive('sendTwoFactorVerificationToken')->andReturnNull();
+
+        $user = factory(User::class)->create();
+
+        $this->post('two-factor/enable', [
+            'user' => $user->id,
+            'country_code' => '1',
+            'phone_number' => '123'
+        ]);
+
+        $this->assertResponseStatus(403)
+            ->dontSeeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => 1,
+                'two_factor_phone' => 123
+            ]);
+    }
+
+    /** @test */
+    public function phone_verification_page_is_not_accessible_if_2fa_is_disabled_on_global_level()
+    {
+        $this->setSettings(['2fa.enabled' => false]);
+
+        $this->createAndLoginUser();
+
+        $this->get("two-factor/verification")
+            ->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function phone_verification_page_is_not_accessible_if_user_phone_is_not_set()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $user1 = $this->createUser(['two_factor_country_code' => null, 'two_factor_phone' => null]);
+        $user2 = $this->createUser(['two_factor_country_code' => 1, 'two_factor_phone' => null]);
+        $user3 = $this->createUser(['two_factor_country_code' => null, 'two_factor_phone' => '123456']);
+
+        $this->actingAs($user1)->get("two-factor/verification")->assertResponseStatus(404);
+        $this->actingAs($user2)->get("two-factor/verification")->assertResponseStatus(404);
+        $this->actingAs($user3)->get("two-factor/verification")->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function users_who_have_already_enabled_2fa_cannot_view_the_phone_verification_page()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+
+        $this->get("two-factor/verification")
+            ->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function users_who_have_already_enabled_2fa_cannot_submit_enable_2fa_form()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+
+        $this->post("two-factor/enable", ['country_code' => '1', 'phone_number' => '123'])
+            ->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function users_who_have_already_enabled_2fa_cannot_submit_verification_form()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+
+        $this->post("two-factor/verify")
+            ->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function token_field_is_required_during_2fa_phone_verification()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser(['two_factor_country_code' => "1", 'two_factor_phone' => "123123"]);
+
+        $this->post("two-factor/verify")
+            ->assertSessionHasErrors('token');
+    }
+
+    /** @test */
+    public function the_2fa_verification_with_wrong_token_will_fail()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $user = $this->createAndLoginUser(['two_factor_country_code' => "1", 'two_factor_phone' => "123123"]);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('tokenIsValid')->with($user, "123123")->andReturn(false);
+
+        $this->visit("two-factor/verification")
+            ->submitForm('Verify', ['token' => '123123'])
+            ->seePageIs("two-factor/verification")
+            ->see('Invalid 2FA Token');
+    }
+
+    /** @test */
+    public function successful_2fa_phone_verification()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->expectsEvents(TwoFactorEnabled::class);
+
+        $user = $this->createAndLoginUser(['two_factor_country_code' => "1", 'two_factor_phone' => "123123"]);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('tokenIsValid')->with($user, '123123')->andReturn(true);
+
+        $this->visit("two-factor/verification")
+            ->submitForm('Verify', ['token' => '123123'])
+            ->seePageIs("profile")
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_options' => '{"enabled":true}'
+            ]);
+    }
+
+    /** @test */
+    public function successful_2fa_phone_verification_for_other_user()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->expectsEvents(TwoFactorEnabledByAdmin::class);
+
+        $this->createAndLoginAdminUser();
+
+        $user = factory(User::class)->create(['two_factor_country_code' => "1", 'two_factor_phone' => "123123"]);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('tokenIsValid')->once()->andReturn(true);
+
+        $this->visit("two-factor/verification?user={$user->id}")
+            ->submitForm('Verify', ['token' => '123123'])
+            ->seePageIs("/user/{$user->id}/edit")
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_options' => '{"enabled":true}'
+            ]);
+    }
+
+    /** @test */
+    public function user_cannot_submit_phone_verification_form_if_phone_is_not_provided()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $user1 = $this->createUser(['two_factor_country_code' => null, 'two_factor_phone' => null]);
+        $user2 = $this->createUser(['two_factor_country_code' => 1, 'two_factor_phone' => null]);
+        $user3 = $this->createUser(['two_factor_country_code' => null, 'two_factor_phone' => '123456']);
+
+        $this->actingAs($user1)->post("two-factor/verify")->assertResponseStatus(404);
+        $this->actingAs($user2)->post("two-factor/verify")->assertResponseStatus(404);
+        $this->actingAs($user3)->post("two-factor/verify")->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function user_can_request_a_new_sms_with_a_code_once_per_minute()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser(['two_factor_country_code' => "1", 'two_factor_phone' => "123123"]);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('sendTwoFactorVerificationToken')->once()->andReturn(false);
+
+        $this->post("/two-factor/resend");
+        $this->post("/two-factor/resend");
+        $this->post("/two-factor/resend");
+    }
+
+    /** @test */
+    public function only_user_with_appropriate_permissions_can_request_new_2fa_token_for_another_user()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        $user = factory(User::class)->create(['two_factor_country_code' => "1", 'two_factor_phone' => "123123"]);
+
+        $this->post("/two-factor/resend", ['user' => $user->id])
+            ->assertResponseStatus(403);
+    }
+
+    /** @test */
+    public function user_can_request_a_new_sms_with_a_code_once_per_minute_while_enabling_2fa_for_other_user()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginAdminUser();
+
+        $user = factory(User::class)->create(['two_factor_country_code' => "1", 'two_factor_phone' => "123123"]);
+
+        $repo = \Mockery::mock(UserRepository::class);
+        $repo->shouldReceive('find')->with($user->id)->andReturn($user);
+        $this->app->instance(UserRepository::class, $repo);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('sendTwoFactorVerificationToken')->once()->with($user)->andReturn(false);
+
+        $this->post("/two-factor/resend", ['user' => $user->id]);
+        $this->post("/two-factor/resend", ['user' => $user->id]);
+        $this->post("/two-factor/resend", ['user' => $user->id]);
+    }
+
+    /** @test */
+    public function users_cannot_request_new_codes_if_they_already_have_2fa_enabled()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('sendTwoFactorVerificationToken')->never();
+
+        $this->post("/two-factor/resend")->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function user_cannot_hit_resend_endpoint_if_phone_is_not_provided()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $user1 = $this->createUser(['two_factor_country_code' => null, 'two_factor_phone' => null]);
+        $user2 = $this->createUser(['two_factor_country_code' => 1, 'two_factor_phone' => null]);
+        $user3 = $this->createUser(['two_factor_country_code' => null, 'two_factor_phone' => '123456']);
+
+        $this->actingAs($user1)->post("/two-factor/resend")->assertResponseStatus(404);
+        $this->actingAs($user2)->post("/two-factor/resend")->assertResponseStatus(404);
+        $this->actingAs($user3)->post("/two-factor/resend")->assertResponseStatus(404);
+    }
+
+    /** @test */
+    public function user_can_disable_2fa()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        $this->expectsEvents(\Portal\Events\User\TwoFactorDisabled::class);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('delete')->andReturnNull();
+
+        $this->visit("profile")
+            ->press('Disable')
+            ->seePageIs("profile")
+            ->see('Two-Factor Authentication disabled successfully.');
+    }
+
+    /** @test */
+    public function user_can_disable_2fa_for_another_user()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->expectsEvents(\Portal\Events\User\TwoFactorDisabled::class);
+
+        $this->createAndLoginAdminUser();
+
+        $user = factory(User::class)->create();
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('delete')->andReturnNull();
+
+        $this->visit("/user/{$user->id}/edit")
+            ->press('Disable')
+            ->seePageIs("/user/{$user->id}/edit")
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => null,
+                'two_factor_phone' => null
+            ])
+            ->see('Two-Factor Authentication disabled successfully.');
+    }
+
+    /** @test */
+    public function user_without_appropriate_permissions_cannot_disable_2fa_for_another_user()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->createAndLoginUser();
+
+        $user = factory(User::class)->create();
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+
+        $this->post("two-factor/disable", ['user' => $user->id])
+            ->assertResponseStatus(403);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Web/UsersControllerTest.php b/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
index ec16b03..cf613e0 100644
--- a/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
@@ -293,54 +293,6 @@ class UsersControllerTest extends FunctionalTestCase
             ->see('Two-Factor Authentication');
     }
 
-    public function test_enable_2fa_for_user()
-    {
-        $this->setSettings([
-            '2fa.enabled' => true
-        ]);
-
-        $this->expectsEvents(TwoFactorEnabledByAdmin::class);
-
-        $user = $this->createAndLoginAdminUser();
-
-        Authy::shouldReceive('isEnabled')->andReturn(false);
-        Authy::shouldReceive('register')->andReturnNull();
-
-        $data = ['country_code' => '1', 'phone_number' => '123'];
-
-        $this->visit("user/{$user->id}/edit")
-            ->submitForm('Enable', $data)
-            ->seePageIs("user/{$user->id}/edit")
-            ->seeInDatabase('users', [
-                'id' => $user->id,
-                'two_factor_country_code' => $data['country_code'],
-                'two_factor_phone' => $data['phone_number']
-            ])
-            ->see('Two-Factor Authentication enabled successfully.');
-    }
-
-    public function test_disable_2fa_for_user()
-    {
-        $this->setSettings(['2fa.enabled' => true]);
-
-        $this->expectsEvents(\Portal\Events\User\TwoFactorDisabledByAdmin::class);
-
-        $user = $this->createAndLoginAdminUser();
-
-        Authy::shouldReceive('isEnabled')->andReturn(true);
-        Authy::shouldReceive('delete')->andReturnNull();
-
-        $this->visit("user/{$user->id}/edit")
-            ->press('Disable')
-            ->seePageIs("user/{$user->id}/edit")
-            ->seeInDatabase('users', [
-                'id' => $user->id,
-                'two_factor_country_code' => null,
-                'two_factor_phone' => null
-            ])
-            ->see('Two-Factor Authentication disabled successfully.');
-    }
-
     public function test_avatar_update()
     {
         $user = $this->createAndLoginAdminUser();
diff --git a/tests/Feature/ImpersonateUsersTest.php b/tests/Feature/ImpersonateUsersTest.php
new file mode 100644
index 0000000..2f12511
--- /dev/null
+++ b/tests/Feature/ImpersonateUsersTest.php
@@ -0,0 +1,96 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Web;
+
+use Tests\Feature\FunctionalTestCase;
+use Portal\User;
+
+class ImpersonateUsersTest extends FunctionalTestCase
+{
+    /** @test */
+    public function a_user_with_appropriate_permission_can_impersonate_other_users_from_a_user_list_page()
+    {
+        $user = $this->createAndLoginUser();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        factory(User::class)->create();
+
+        $this->visit('/user')->see("Impersonate");
+    }
+
+    /** @test */
+    public function a_user_dont_see_impersonate_button_next_to_his_name_in_the_user_list()
+    {
+        $user = $this->createAndLoginUser();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $this->visit('/user')->dontSee("Impersonate");
+    }
+
+    /** @test */
+    public function clicking_on_impersonate_button_will_impersonate_the_user()
+    {
+        $user1 = $this->createAndLoginUser();
+
+        $this->addPermissionForUser($user1, 'users.manage');
+
+        $user2 = factory(User::class)->create();
+
+        $this->assertTrue(auth()->user()->is($user1));
+
+        $this->visit('/user')
+            ->click("Impersonate")
+            ->seePageIs("/");
+
+        $this->assertTrue(auth()->user()->is($user2));
+    }
+
+    /** @test */
+    public function while_impersonating_user_can_stop_impersonating_by_clicking_on_the_header_button()
+    {
+        $user = $this->createAndLoginUser();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        factory(User::class)->create();
+
+        $this->visit('/user')
+            ->click("Impersonate")
+            ->see("Stop Impersonating");
+
+        $this->click("Stop Impersonating");
+
+        $this->assertTrue(auth()->user()->is($user));
+    }
+
+    /** @test */
+    public function while_impersonating_user_cannot_impersonate_other_user_even_if_he_has_a_permission()
+    {
+        $user1 = $this->createAndLoginUser();
+        $user2 = factory(User::class)->create();
+
+        $this->addPermissionForUser($user1, 'users.manage');
+        $this->addPermissionForUser($user2, 'users.manage');
+
+        $this->visit("/user")
+            ->click("Impersonate")
+            ->visit("/user")
+            ->dontSeeElement(".impersonate");
+    }
+
+    /** @test */
+    public function user_can_be_impersonated_by_clicking_on_impersonate_link_on_user_profile_page()
+    {
+        $user1 = $this->createAndLoginUser();
+        $user2 = factory(User::class)->create();
+
+        $this->addPermissionForUser($user1, 'users.manage');
+
+        $this->visit("/user/{$user2->id}/show")->click("Impersonate");
+
+        $this->seePageIs("/");
+        $this->assertTrue(auth()->user()->is($user2));
+    }
+}
diff --git a/tests/Feature/Listeners/UserEventsSubscriberTest.php b/tests/Feature/Listeners/UserEventsSubscriberTest.php
index 1cf2f9e..0cb1bfa 100644
--- a/tests/Feature/Listeners/UserEventsSubscriberTest.php
+++ b/tests/Feature/Listeners/UserEventsSubscriberTest.php
@@ -2,10 +2,6 @@
 
 namespace Tests\Feature\Listeners;
 
-use Mockery as m;
-use Portal\Services\Logging\UserActivity\Activity;
-use Portal\User;
-
 class UserEventsSubscriberTest extends BaseListenerTestCase
 {
     protected $theUser;
@@ -155,4 +151,28 @@ class UserEventsSubscriberTest extends BaseListenerTestCase
         event(new \Portal\Events\User\ResetedPasswordViaEmail($this->user));
         $this->assertMessageLogged("Reseted password using \"Forgot Password\" option.");
     }
+
+    public function test_onStartImpersonating()
+    {
+        $impersonated = factory(\Portal\User::class)->create([
+            'first_name' => 'John',
+            'last_name' => 'Doe'
+        ]);
+
+        event(new \Lab404\Impersonate\Events\TakeImpersonation($this->user, $impersonated));
+
+        $this->assertMessageLogged("Started impersonating user John Doe (ID: {$impersonated->id})");;
+    }
+
+    public function test_onStopImpersonating()
+    {
+        $impersonated = factory(\Portal\User::class)->create([
+            'first_name' => 'John',
+            'last_name' => 'Doe'
+        ]);
+
+        event(new \Lab404\Impersonate\Events\LeaveImpersonation($this->user, $impersonated));
+
+        $this->assertMessageLogged("Stopped impersonating user John Doe (ID: {$impersonated->id})");
+    }
 }
diff --git a/webpack.mix.js b/webpack.mix.js
index c9916e5..63031bb 100644
--- a/webpack.mix.js
+++ b/webpack.mix.js
@@ -30,7 +30,7 @@ mix.styles([
     'public/assets/plugins/croppie/croppie.css',
 ], 'public/assets/css/vendor.css');
 
-mix.sass('resources/assets/sass/app.scss', 'public/assets/css');
+mix.sass('resources/sass/app.scss', 'public/assets/css');
 
 if (mix.inProduction()) {
     mix.version();
